/**
 * DO NOT EDIT
 *
 * This file was automatically generated by
 *   https://github.com/Polymer/tools/tree/master/packages/gen-typescript-declarations
 *
 * To modify these typings, edit the source file(s):
 *   src/ApiParametersDocument.js
 */


// tslint:disable:variable-name Describing an API that's defined elsewhere.
// tslint:disable:no-any describes the API as best we are able today

import {LitElement, html, css} from 'lit-element';

export {ApiParametersDocument};

declare namespace ApiElements {

  /**
   * `api-parameters-document`
   *
   * URI and query parameters documentation table based on
   * [AMF](https://github.com/mulesoft/amf) json/ld model.
   *
   * It rquires you to set at least one of the following properties:
   * - baseUriParameters
   * - endpointParameters
   * - queryParameters
   *
   * Otherwise it render empty block element.
   *
   * See demo for example implementation.
   */
  class ApiParametersDocument extends LitElement {
    legacy: boolean|null|undefined;

    /**
     * The `http://raml.org/vocabularies/http#variable` entry
     * from API's `http://raml.org/vocabularies/http#server` model.
     */
    baseUriParameters: Array<object|null>|null;

    /**
     * Endpoint path parameters as
     * `http://raml.org/vocabularies/http#parameter` property value of the
     * type of `http://raml.org/vocabularies/http#EndPoint`
     */
    endpointParameters: Array<object|null>|null;

    /**
     * `raml-aware` scope property to use.
     */
    aware: string|null|undefined;

    /**
     * Generated AMF json/ld model form the API spec.
     * The element assumes the object of the first array item to be a
     * type of `"http://raml.org/vocabularies/document#Document`
     * on AMF vocabulary.
     *
     * It is only usefult for the element to resolve references.
     */
    amf: object|any[]|null;

    /**
     * Set to true to open the query parameters view.
     * Autormatically updated when the view is toggled from the UI.
     */
    queryOpened: boolean|null|undefined;

    /**
     * Set to true to open the path parameters view.
     * Autormatically updated when the view is toggled from the UI.
     */
    pathOpened: boolean|null|undefined;

    /**
     * Method query parameters as
     * `http://raml.org/vocabularies/http#parameter` property value of the
     * type of `http://raml.org/vocabularies/http#Request`
     */
    queryParameters: Array<object|null>|null;

    /**
     * Set to render a mobile friendly view.
     */
    narrow: boolean|null|undefined;

    /**
     * Enables compatibility with Anypoint components.
     */
    compatibility: boolean|null|undefined;

    /**
     * Type of the header in the documentation section.
     * Should be in range of 1 to 6.
     */
    headerLevel: number|null|undefined;

    /**
     * Passed to `api-type-document`. Enables internal links rendering for types.
     */
    graph: boolean|null|undefined;
    _effectivePathParameters: any[]|null|undefined;
    constructor();
    render(): any;
    _sop(prop: any, value: any): any;

    /**
     * Handler for amf model change from `raml-aware`
     */
    _apiChangedHandler(e: CustomEvent|null): void;

    /**
     * Computes combined array of base uri parameters and selected endpoint
     * parameters so the element can render single documentation table.
     *
     * @param base Base uri parameetrs
     * @param endpoint Endpoint's uri parameters
     * @returns Combined array. Can be empty array if arguments does not
     * contain values.
     */
    _computeEffectivePath(base: any[]|null, endpoint: any[]|null): any[]|null;

    /**
     * Computes a label for the section toggle buttons.
     */
    _computeToggleActionLabel(opened: any): any;

    /**
     * Computes class for the toggle's button icon.
     */
    _computeToggleIconClass(opened: any): any;

    /**
     * Toggles URI parameters view.
     * Use `pathOpened` property instead.
     */
    toggleUri(): void;

    /**
     * Toggles `queryOpened` value.
     */
    toggleQuery(): void;
  }
}
